unit Unit1;

interface

uses
  Windows, Printers, Jpeg, ShellAPI, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FileCtrl, StdCtrls, ExtCtrls, ComCtrls, Menus, ToolWin, StdActns,
  ActnList, ImgList, Grids, Outline, DirOutln, Gauges;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    FileListBox1: TFileListBox;
    Panel2: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    MainMenu1: TMainMenu;
    Tools1: TMenuItem;
    Tool1: TMenuItem;
    File1: TMenuItem;
    Preview1: TMenuItem;
    View1: TMenuItem;
    N1: TMenuItem;
    Print1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Refresh1: TMenuItem;
    Exit1: TMenuItem;
    DirectoryListBox1: TDirectoryListBox;
    Align: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Move1: TMenuItem;
    Copy1: TMenuItem;
    Rename1: TMenuItem;
    Delete1: TMenuItem;
    Attributes1: TMenuItem;
    N5: TMenuItem;
    Open1: TMenuItem;
    N4: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    RefreshButton: TToolButton;
    PreviewButton: TToolButton;
    ViewButton: TToolButton;
    PrintButton: TToolButton;
    AboutButton: TToolButton;
    ComboBox1: TComboBox;
    OpenButton: TToolButton;
    CopyButton: TToolButton;
    MoveButton: TToolButton;
    DeleteButton: TToolButton;
    ActionList1: TActionList;
    ShellOpen: TAction;
    Refresh: TAction;
    Preview: TAction;
    View: TAction;
    Print: TAction;
    CopyTo: TAction;
    MoveTo: TAction;
    Delete: TAction;
    About: TAction;
    Rename: TAction;
    Attributes: TAction;
    QuitApp: TAction;
    RenameButton: TToolButton;
    AddToFavor: TAction;
    N6: TMenuItem;
    AddToFavorites1: TMenuItem;
    DelFromFavor: TAction;
    DelFromFavor1: TMenuItem;
    OrganizeFavor: TAction;
    OrganizeFavor1: TMenuItem;
    ImageList1: TImageList;
    Timer1: TTimer;
    N7: TMenuItem;
    SlideShowoptions1: TMenuItem;
    SlideOptions: TAction;
    StartSlide: TAction;
    ProgressBar1: TProgressBar;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    ToolBar3: TToolBar;
    SlideButton: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    SlideOpButton: TToolButton;
    Timer2: TTimer;
    Timer3: TTimer;
    PopupMenu1: TPopupMenu;
    Open2: TMenuItem;
    Copy2: TMenuItem;
    Move2: TMenuItem;
    Rename2: TMenuItem;
    N8: TMenuItem;
    Delete2: TMenuItem;
    N9: TMenuItem;
    FileAttributes1: TMenuItem;
    PopupMenu2: TPopupMenu;
    Shrin1: TMenuItem;
    Slide1: TMenuItem;
    StartSlide1: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    HideCursor1: TMenuItem;
    PopupMenu3: TPopupMenu;
    HideCursor2: TMenuItem;
    procedure FileListBox1Click(Sender: TObject);
    procedure FileListBox1DblClick(Sender: TObject);
    procedure Tool1Click(Sender: TObject);
    procedure FileListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Image1Progress(Sender: TObject; Stage: TProgressStage;
      PercentDone: Byte; RedrawNow: Boolean; const R: TRect;
      const Msg: String);
    procedure Left1Click(Sender: TObject);
    procedure Right1Click(Sender: TObject);
    procedure ShellOpenExecute(Sender: TObject);
    procedure RefreshExecute(Sender: TObject);
    procedure PreviewExecute(Sender: TObject);
    procedure ViewExecute(Sender: TObject);
    procedure PrintExecute(Sender: TObject);
    procedure CopyToExecute(Sender: TObject);
    procedure MoveToExecute(Sender: TObject);
    procedure DeleteExecute(Sender: TObject);
    procedure AboutExecute(Sender: TObject);
    procedure RenameExecute(Sender: TObject);
    procedure AttributesExecute(Sender: TObject);
    procedure QuitAppExecute(Sender: TObject);
    procedure AddToFavorExecute(Sender: TObject);
    procedure DelFromFavorExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OrganizeFavorExecute(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SlideOptionsExecute(Sender: TObject);
    procedure StartSlideExecute(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure HideCursor1Click(Sender: TObject);
  private
    { Private declarations }
    function FileDateTime(const FileName: string): TDateTime;
    procedure FileChange(Sender: TObject);
    procedure FileDel;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  PicFile: TFileName;

implementation

uses Unit2, Unit3, Unit4, Unit5, Unit6, Unit7;

{$R *.DFM}

function TForm1.FileDateTime(const FileName: string): System.TDateTime;
begin
  Result := FileDateToDateTime(FileAge(FileName));
end;

procedure TForm1.FileDel;
begin
  with FileListBox1 do
    if MessageDlg('Delete ' + FileName + '?', mtConfirmation,
      [mbYes, mbNo], 0) = mrYes then
      if DeleteFile(FileName) then Update;
end;

procedure TForm1.FileListBox1Click(Sender: TObject);
begin
 PicFile := FileListBox1.FileName;
 try
 Image1.Picture.LoadFromFile(PicFile);
 Form2.Image1.Picture.LoadFromFile(PicFile);
 except
      Image1.Picture.Graphic := nil;
      Form2.Image1.Picture.Graphic := nil;
 end;
 Combobox1.text := PicFile;
 Caption := FileListBox1.Items[FileListBox1.ItemIndex] + ' - Graphic Browser';
end;

procedure TForm1.FileListBox1DblClick(Sender: TObject);
begin
Form2.ShowModal;
end;

procedure TForm1.Tool1Click(Sender: TObject);
begin
Tool1.Checked := not Tool1.Checked;
Shrin1.Checked := not Shrin1.Checked;
if Tool1.Checked = true then Image1.Align := alClient else Image1.Align := alNone;
end;

procedure TForm1.FileListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if KEY = VK_DELETE then FileDel;
if KEY = VK_RETURN then Form2.ShowModal;
end;

procedure TForm1.Image1Progress(Sender: TObject; Stage: TProgressStage;
  PercentDone: Byte; RedrawNow: Boolean; const R: TRect;
  const Msg: String);
begin
if Stage = psRunning then
ProgressBar1.Position := PercentDone else ProgressBar1.position := 0;
end;

procedure TForm1.Left1Click(Sender: TObject);
begin
Left1.Checked := true;
Panel2.Align := alLeft;
Splitter1.Align := alLeft;
end;

procedure TForm1.Right1Click(Sender: TObject);
begin
Right1.Checked := true;
Panel2.Align := alRight;
Splitter1.Align := alRight;
end;

procedure TForm1.FileChange(Sender: TObject);
begin
  with ChangeDlg do
  begin
    if Sender = Move1 then Caption := 'Move'
    else if Sender = Copy1 then Caption := 'Copy'
    else if Sender = Rename1 then Caption := 'Rename'
    else Exit;
    CurrentDir.Caption := Form1.DirectoryListBox1.Directory;
    FromFileName.Text := FileListBox1.FileName;
    ToFileName.text := FromFileName.text;
    ListBox1.Items.LOadFromFile('C:\recent.txt');
    if (ShowModal <> mrCancel) and (ToFileName.Text <> '') then
    //*************
    begin
      ListBox1.Items.Add(CurrentDir.Caption);
      if MessageDlg(Format('%s %s to %s?', [Caption, FromFileName.text, ToFileName.text]),
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    if Caption = 'Move' then
      MoveFile(PChar(FromFileName.text), PChar(ToFileName.text))
    else if Caption = 'Copy' then
      CopyFile( PChar(FromFileName.text), PChar(ToFileName.text) ,true)
    else if Caption = 'Rename' then
      RenameFile(PChar(FromFileName.text), PChar(ToFileName.text));
    ListBox1.Items.SaveToFile('C:\recent.txt');
    FileListBox1.Update;
  end;
    end;
    //************
  end;
end;

procedure TForm1.ShellOpenExecute(Sender: TObject);
begin
ShellExecute(Handle, nil, PChar(FileListBox1.FileName), nil, nil, SW_SHOWNORMAL);
end;

procedure TForm1.RefreshExecute(Sender: TObject);
begin
FileListBox1.Update;
DirectoryListBox1.Update;
DriveComboBox1.Update;
FilterComboBox1.Update;
Image1.Update;
Preview1.Click;
end;

procedure TForm1.PreviewExecute(Sender: TObject);
begin
try
Image1.Picture.LoadFromFile(PicFile);
    except
    on EInvalidGraphic do
    Image1.Picture := nil;
    end;
end;

procedure TForm1.ViewExecute(Sender: TObject);
begin
 try
 Form2.Image1.Picture.LoadFromFile(PicFile);
 except
    on EInvalidGraphic do
      Form2.Image1.Picture.Graphic := nil;
      end;
Form2.ShowModal;
end;

procedure TForm1.PrintExecute(Sender: TObject);
begin
  with Printer do
  begin
    BeginDoc;
    Canvas.Draw(0, 0, Image1.Picture.Graphic);
    EndDoc;
  end;
end;

procedure TForm1.CopyToExecute(Sender: TObject);
begin
FileChange(Copy1);
end;

procedure TForm1.MoveToExecute(Sender: TObject);
begin
FileChange(Move1);
end;

procedure TForm1.DeleteExecute(Sender: TObject);
begin
FileDel;
end;

procedure TForm1.AboutExecute(Sender: TObject);
begin
AboutBox.ShowModal;
end;

procedure TForm1.RenameExecute(Sender: TObject);
begin
FileChange(Rename1);
end;

procedure TForm1.AttributesExecute(Sender: TObject);
var
  Attributes, NewAttributes: Word;
begin
  with FileAttrForm do
  begin
    FileDirName.Caption := FileListBox1.Items[FileListBox1.ItemIndex];
    FilePathName.Caption := FileListBox1.Directory;
    ChangeDate.Caption := DateTimeToStr(FileDateTime(FileListBox1.FileName));
    Attributes := FileGetAttr(FileDirName.Caption);
    ReadOnly.Checked := (Attributes and faReadOnly) = faReadOnly;
    Archive.Checked := (Attributes and faArchive) = faArchive;
    System.Checked := (Attributes and faSysFile) = faSysFile;
    Hidden.Checked := (Attributes and faHidden) = faHidden;
    if ShowModal <> mrCancel then
    begin
      NewAttributes := Attributes;
      if ReadOnly.Checked then NewAttributes := NewAttributes or faReadOnly
      else NewAttributes := NewAttributes and not faReadOnly;
      if Archive.Checked then NewAttributes := NewAttributes or faArchive
      else NewAttributes := NewAttributes and not faArchive;
      if System.Checked then NewAttributes := NewAttributes or faSysFile
      else NewAttributes := NewAttributes and not faSysFile;
      if Hidden.Checked then NewAttributes := NewAttributes or faHidden
      else NewAttributes := NewAttributes and not faHidden;
      if NewAttributes <> Attributes then
        FileSetAttr(FileDirName.Caption, NewAttributes);
    end;
  end;
end;

procedure TForm1.QuitAppExecute(Sender: TObject);
begin
close;
end;

procedure TForm1.AddToFavorExecute(Sender: TObject);
begin
ComboBox1.Items.Add(ComboBox1.text);
end;

procedure TForm1.DelFromFavorExecute(Sender: TObject);
begin
ComboBox1.Items.Delete(ComboBox1.ItemIndex);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
ComboBox1.Items.LoadFromFile('c:\favorites.txt');
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
ComboBox1.Items.SaveToFile('c:\favorites.txt');
end;

procedure TForm1.OrganizeFavorExecute(Sender: TObject);
begin
Form6.ShowModal;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
try
Image1.Picture.LoadFromFile(ComboBox1.Text)
except
Image1.Picture := nil;
end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
FileListBox1.ItemIndex := FileListBox1.ItemIndex + 1;
try
Image1.Picture.LoadFromFile(FileListBox1.FileName);
Form2.Image1.Picture.LoadFromFile(FileListBox1.FileName);
except
Image1.Picture := nil;
Form2.Image1.Picture := nil;
end;
if FileListBox1.ItemIndex = FileListBox1.Items.Count - 1 then FileListBox1.ItemIndex := 0;
end;

procedure TForm1.SlideOptionsExecute(Sender: TObject);
begin
Form7.ShowModal;
end;

procedure TForm1.StartSlideExecute(Sender: TObject);
begin
if SlideButton.Caption = 'Start'
then
   begin
   if Form7.RadioButton1.Checked = true then Timer1.Enabled := true;
   if Form7.RadioButton2.Checked = true then Timer2.Enabled := true;
   if Form7.RadioButton3.Checked = true then Timer3.Enabled := true;
   StartSlide1.Caption := 'Stop Slide show';
   SlideButton.Caption := 'Stop';
   end else
      begin
      Timer1.Enabled := false;
      Timer2.Enabled := false;
      Timer3.Enabled := false;
      StartSlide1.Caption := 'Start Slide show';
      SlideButton.Caption := 'Start';
      end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
FileListBox1.ItemIndex := FileListBox1.ItemIndex - 1;
try
Image1.Picture.LoadFromFile(FileListBox1.FileName);
Form2.Image1.Picture.LoadFromFile(FileListBox1.FileName);
except
Image1.Picture := nil;
Form2.Image1.Picture := nil;
end;
if FileListBox1.ItemIndex = - 1 then FileListBox1.ItemIndex := FileListBox1.Items.Count - 1;
end;

procedure TForm1.Timer3Timer(Sender: TObject);
begin
Randomize;
FileListBox1.ItemIndex := FileListBox1.ItemIndex + Random(8);
try
Image1.Picture.LoadFromFile(FileListBox1.FileName);
Form2.Image1.Picture.LoadFromFile(FileListBox1.FileName);
except
Image1.Picture := nil;
Form2.Image1.Picture := nil;
end;
if FileListBox1.ItemIndex > FileListBox1.Items.Count - 9 then FileListBox1.ItemIndex := 0;
end;

procedure TForm1.HideCursor1Click(Sender: TObject);
begin
HideCursor1.Checked := not HideCursor1.Checked;
HideCursor2.Checked := not HideCursor2.Checked;
if HideCursor1.checked = true then
   begin
   Form2.Cursor := crNone;
   Form2.ScrollBox1.Cursor := crNone;
   Form2.Image1.Cursor := crNone;
   end else
   begin
   Form2.Cursor := crDefault;
   Form2.ScrollBox1.Cursor := crDefault;
   Form2.Image1.Cursor := crDefault;
   end;
end;

end.
